﻿IF NOT EXISTS (SELECT 1 FROM SysLic)
	RETURN;

IF OBJECT_ID('TRFreezeSysModuleEntity') IS NOT NULL
	DROP TRIGGER TRFreezeSysModuleEntity;

DECLARE @CreateTrigger NVARCHAR(MAX) =
'CREATE TRIGGER TRFreezeSysModuleEntity ON SysModuleEntity
AFTER UPDATE
AS 
BEGIN
	SET NOCOUNT ON;

	IF (SELECT TRIGGER_NESTLEVEL()) > 1
		RETURN;

	DECLARE @Id UNIQUEIDENTIFIER;
	DECLARE @TypeColumnUId UNIQUEIDENTIFIER;

	SELECT
		@Id = Id,
		@TypeColumnUId = TypeColumnUId
	FROM DELETED;

	IF UPDATE(TypeColumnUId)
	BEGIN
		PRINT CONCAT(''Rollback changes for SysModuleEntity: Id = {'', @Id, ''}; TypeColumnUId = {'', @TypeColumnUId, ''}'');
		UPDATE SysModuleEntity
		SET TypeColumnUId = @TypeColumnUId
		WHERE Id = @Id;
    END
END';
EXEC(@CreateTrigger);